#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <math.h>
#include "effectdll.h"

union DWORDBYTE
{
	DWORD dw;
	BYTE b[4];
};

union DWORDWORD
{
	DWORD dw;
	WORD w[2];
};

union WORDBYTE
{
	WORD w;
	BYTE b[2];
};

//	ΉVisual Clipper̃o[W\܂B
#define EFFECT_HOST_VERSION					0x00020000

//	ʂ̏zƂĊi[Ă܂B
EFFECTINFO g_EffectInfo[] = {
	{0, EFFECT_HOST_VERSION, 0x00010000, 0, NULL, 0, L"Null", L"Kawamoto", L"܂B"},
	{1, EFFECT_HOST_VERSION, 0x00010000, 0, NULL, 0, L"Paint", L"Kawamoto", L"ό`ꂽ`͈̔͂w肳ꂽFœhԂ܂B"},
	{2, EFFECT_HOST_VERSION, 0x00010000, 0, NULL, 0, L"PaintRect", L"Kawamoto", L"ʏ̋`͈̔͂w肳ꂽFœhԂ܂B"},
	{3, EFFECT_HOST_VERSION, 0x00010000, 0, NULL, 0, L"MonochromeRect", L"Kawamoto", L"ʏ̋`͈̔͂EF܂B"},
};

BYTE g_MultiplyColorTable[256][256];
BYTE g_AddColorTable[256][256];
BYTE g_SubtractColorTable[256][256];
WORD g_BlendColorAlphaTable[256][256];
DWORDBYTE g_MonochromeTable[766];

//	ʃvOC̓ǂݍݎɌĂяo܂B
BOOL WINAPI DllMain(HANDLE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	DWORD i;
	DWORD j;
	if(fdwReason == DLL_PROCESS_ATTACH)
	{
		//	ŎgpϐĂB
		for(i = 0 ; i < 256; i++)
		{
			for(j = 0 ; j < 256; j++)
				g_MultiplyColorTable[i][j] = (BYTE)(i * j / 255);
		}
		for(i = 0 ; i < 256; i++)
		{
			for(j = 0 ; j < 256; j++)
				g_AddColorTable[i][j] = (BYTE)(i + j > 255 ? 255 : i + j);
		}
		for(i = 0 ; i < 256; i++)
		{
			for(j = 0 ; j < 256; j++)
				g_SubtractColorTable[i][j] = (BYTE)(i - j > 255 ? 0 : i - j);
		}
		for(i = 0 ; i < 256; i++)
		{
			for(j = 0 ; j < 256; j++)
				g_BlendColorAlphaTable[i][j] = (WORD)(i * j);
		}
		for(i = 0; i < 766; i++)
		{
			g_MonochromeTable[i].b[0] = (BYTE)(sqrt((DOUBLE)i) * 9.2195444572928873100022742817656 + 0.5);
			g_MonochromeTable[i].b[1] = g_MonochromeTable[i].b[0];
			g_MonochromeTable[i].b[2] = g_MonochromeTable[i].b[0];
			g_MonochromeTable[i].b[3] = 0;
		}
	}
	return TRUE;
}

//	w肳ꂽʂgp\ǂԂĂB
//	̊֐__stdcallƂăGNX|[gĂB
//	w肳ꂽԍ̌ʂ݂1AłȂꍇ0ԂĂB
//	Effect͌ʂ̔ԍ܂B
//	pEffectInfo͌ʂ̏i[邽߂̃|C^܂B
//	ԍɑΉʂ݂ꍇɁApEffectInfoNULLłȂȂ΂̏i[ĂB
BOOL CALLBACK QueryEffect(DWORD Effect, EFFECTINFO* pEffectInfo)
{
	switch(Effect)
	{
	case 0:
	case 1:
	case 2:
	case 3:
		if(pEffectInfo)
			*pEffectInfo = g_EffectInfo[Effect];
		return TRUE;
		break;
	}
	return FALSE;
}

//	ʂ̌ԂĂB
//	̊֐__stdcallƂăGNX|[gĂB
//	pEffectInfo͌ʂ̏i[邽߂̃|C^܂B
//	pEffectInfoNULLłȂȂ΁Aʂ̏zƂĊi[ǍԂĂB
DWORD CALLBACK EnumEffect(EFFECTINFO* pEffectInfo)
{
	if(pEffectInfo)
		memcpy(pEffectInfo, &g_EffectInfo, sizeof(EFFECTINFO) * 4);
	return 4;
}

BOOL EffectNull(void* pDestBits, DWORD DestPitch, DWORD DestHeight, RECT* pDestRect, RECT* pSrcRect, COLORREF Color, DWORD BlendMode, TRANSFORMMATRIX* pMatrix, TRANSFORMMATRIX* pInverse)
{
	return TRUE;
}

inline DWORD MultiplyColor(DWORD Color1, DWORD Color2)
{
	DWORDBYTE dw;
	dw.b[0] = g_MultiplyColorTable[(*(DWORDBYTE*)&Color1).b[0]][(*(DWORDBYTE*)&Color2).b[0]];
	dw.b[1] = g_MultiplyColorTable[(*(DWORDBYTE*)&Color1).b[1]][(*(DWORDBYTE*)&Color2).b[1]];
	dw.b[2] = g_MultiplyColorTable[(*(DWORDBYTE*)&Color1).b[2]][(*(DWORDBYTE*)&Color2).b[2]];
	dw.b[3] =  0;
	return dw.dw;
}

inline DWORD AddColor(DWORD Color1, DWORD Color2)
{
	DWORDBYTE dw;
	dw.b[0] = g_AddColorTable[(*(DWORDBYTE*)&Color1).b[0]][(*(DWORDBYTE*)&Color2).b[0]];
	dw.b[1] = g_AddColorTable[(*(DWORDBYTE*)&Color1).b[1]][(*(DWORDBYTE*)&Color2).b[1]];
	dw.b[2] = g_AddColorTable[(*(DWORDBYTE*)&Color1).b[2]][(*(DWORDBYTE*)&Color2).b[2]];
	dw.b[3] =  0;
	return dw.dw;
}

inline DWORD SubtractColor(DWORD Color1, DWORD Color2)
{
	DWORDBYTE dw;
	dw.b[0] = g_SubtractColorTable[(*(DWORDBYTE*)&Color1).b[0]][(*(DWORDBYTE*)&Color2).b[0]];
	dw.b[1] = g_SubtractColorTable[(*(DWORDBYTE*)&Color1).b[1]][(*(DWORDBYTE*)&Color2).b[1]];
	dw.b[2] = g_SubtractColorTable[(*(DWORDBYTE*)&Color1).b[2]][(*(DWORDBYTE*)&Color2).b[2]];
	dw.b[3] =  0;
	return dw.dw;
}

inline DWORD BlendColorAlpha(DWORD Color1, DWORD Color2, DWORD Alpha1, DWORD Alpha2)
{
	DWORDBYTE dw;
	dw.b[0] = (BYTE)((g_BlendColorAlphaTable[Alpha1][(*(DWORDBYTE*)&Color1).b[0]] + g_BlendColorAlphaTable[Alpha2][(*(DWORDBYTE*)&Color2).b[0]]) >> 8);
	dw.b[1] = (BYTE)((g_BlendColorAlphaTable[Alpha1][(*(DWORDBYTE*)&Color1).b[1]] + g_BlendColorAlphaTable[Alpha2][(*(DWORDBYTE*)&Color2).b[1]]) >> 8);
	dw.b[2] = (BYTE)((g_BlendColorAlphaTable[Alpha1][(*(DWORDBYTE*)&Color1).b[2]] + g_BlendColorAlphaTable[Alpha2][(*(DWORDBYTE*)&Color2).b[2]]) >> 8);
	dw.b[3] =  0;
	return dw.dw;
}

BOOL EffectPaint(void* pDestBits, DWORD DestPitch, DWORD DestHeight, RECT* pDestRect, RECT* pSrcRect, COLORREF Color, DWORD BlendMode, TRANSFORMMATRIX* pMatrix, TRANSFORMMATRIX* pInverse)
{
	DWORD* pDest;
	DWORD* pLine;
	LONG x;
	LONG y;
	LONG DestLeft;
	LONG DestRight;
	LONG DestTop;
	LONG DestBottom;
	TRANSFORMMATRIX Inverse;
	FLOAT fx;
	FLOAT fy;
	FLOAT fSrcLeft;
	FLOAT fSrcRight;
	FLOAT fSrcTop;
	FLOAT fSrcBottom;
	LONG SrcLeft;
	LONG SrcRight;
	LONG SrcTop;
	LONG SrcBottom;
	DWORD Alpha;
	DWORD InvAlpha;
	TRANSFORMMATRIX Matrix;
	LONG lx[4];
	LONG ly[4];
	LONG mx[2];
	LONG my[2];
	if(!pMatrix && !pInverse)
		return FALSE;
	pDest = (DWORD*)pDestBits + DestPitch * (DestHeight - 1);
	DestLeft = pDestRect->left;
	DestRight = pDestRect->right;
	DestTop = pDestRect->top;
	DestBottom = pDestRect->bottom;
	if(DestLeft < 0)
		DestLeft = 0;
	if(DestRight > (LONG)DestPitch)
		DestRight = (LONG)DestPitch;
	if(DestTop < 0)
		DestTop = 0;
	if(DestBottom > (LONG)DestHeight)
		DestBottom = (LONG)DestHeight;
	SrcLeft = pSrcRect->left;
	SrcRight = pSrcRect->right;
	SrcTop = pSrcRect->top;
	SrcBottom = pSrcRect->bottom;
	if(SrcLeft < 0)
		SrcLeft = 0;
	if(SrcTop < 0)
		SrcTop = 0;
	fSrcLeft = (FLOAT)SrcLeft;
	fSrcRight = (FLOAT)SrcRight;
	fSrcTop = (FLOAT)SrcTop;
	fSrcBottom = (FLOAT)SrcBottom;
	Alpha = (Color & 0xff000000) >> 24;
	InvAlpha = 0x00000100 - Alpha;
	if(pMatrix)
		Matrix = *pMatrix;
	if(pInverse)
		Inverse = *pInverse;
	if(!pMatrix)
	{
		Matrix = Inverse;
		Matrix.SetInverse();
	}
	if(!pInverse)
	{
		Inverse = Matrix;
		Inverse.SetInverse();
	}
	Matrix.TransformIntegerB(lx[0], ly[0], SrcLeft, SrcTop);
	Matrix.TransformIntegerB(lx[1], ly[1], SrcRight, SrcTop);
	Matrix.TransformIntegerB(lx[2], ly[2], SrcLeft, SrcBottom);
	Matrix.TransformIntegerB(lx[3], ly[3], SrcRight, SrcBottom);
	mx[0] = lx[0];
	if(lx[1] < mx[0])
		mx[0] = lx[1];
	if(lx[2] < mx[0])
		mx[0] = lx[2];
	if(lx[3] < mx[0])
		mx[0] = lx[3];
	mx[0] -= 1;
	mx[1] = lx[0];
	if(lx[1] > mx[1])
		mx[1] = lx[1];
	if(lx[2] > mx[1])
		mx[1] = lx[2];
	if(lx[3] > mx[1])
		mx[1] = lx[3];
	mx[1] += 1;
	my[0] = ly[0];
	if(ly[1] < my[0])
		my[0] = ly[1];
	if(ly[2] < my[0])
		my[0] = ly[2];
	if(ly[3] < my[0])
		my[0] = ly[3];
	my[0] -= 1;
	my[1] = ly[0];
	if(ly[1] > my[1])
		my[1] = ly[1];
	if(ly[2] > my[1])
		my[1] = ly[2];
	if(ly[3] > my[1])
		my[1] = ly[3];
	my[1] += 1;
	if(mx[0] > DestLeft)
		DestLeft = mx[0];
	if(mx[1] < DestRight)
		DestRight = mx[1];
	if(my[0] > DestTop)
		DestTop = my[0];
	if(my[1] < DestBottom)
		DestBottom = my[1];
	Color = ((Color & 0x000000ff) << 16) | (Color & 0x0000ff00) | ((Color & 0x00ff0000) >> 16);
	switch(BlendMode)
	{
	case BLEND_MODE_DEFAULT:
		if(Alpha == 0)
		{
			pLine = pDest - DestTop * DestPitch + DestLeft;
			y = DestTop;
			while(y < DestBottom)
			{
				pDest = pLine;
				x = DestLeft;
				while(x < DestRight)
				{
					Inverse.Transform(fx, fy, (FLOAT)x, (FLOAT)y);
					if(fx >= fSrcLeft && fx < fSrcRight && fy >= fSrcTop && fy < fSrcBottom)
						*pDest = Color;
					pDest++;
					x++;
				}
				y++;
				pLine -= DestPitch;
			}
		}
		else
		{
			pLine = pDest - DestTop * DestPitch + DestLeft;
			y = DestTop;
			while(y < DestBottom)
			{
				pDest = pLine;
				x = DestLeft;
				while(x < DestRight)
				{
					Inverse.Transform(fx, fy, (FLOAT)x, (FLOAT)y);
					if(fx >= fSrcLeft && fx < fSrcRight && fy >= fSrcTop && fy < fSrcBottom)
						*pDest = BlendColorAlpha(Color, *pDest, Alpha, InvAlpha);
					pDest++;
					x++;
				}
				y++;
				pLine -= DestPitch;
			}
		}
		break;
	case BLEND_MODE_AND:
		pLine = pDest - DestTop * DestPitch + DestLeft;
		y = DestTop;
		while(y < DestBottom)
		{
			pDest = pLine;
			x = DestLeft;
			while(x < DestRight)
			{
				Inverse.Transform(fx, fy, (FLOAT)x, (FLOAT)y);
				if(fx >= fSrcLeft && fx < fSrcRight && fy >= fSrcTop && fy < fSrcBottom)
					*pDest &= Color;
				pDest++;
				x++;
			}
			y++;
			pLine -= DestPitch;
		}
		break;
	case BLEND_MODE_OR:
		pLine = pDest - DestTop * DestPitch + DestLeft;
		y = DestTop;
		while(y < DestBottom)
		{
			pDest = pLine;
			x = DestLeft;
			while(x < DestRight)
			{
				Inverse.Transform(fx, fy, (FLOAT)x, (FLOAT)y);
				if(fx >= fSrcLeft && fx < fSrcRight && fy >= fSrcTop && fy < fSrcBottom)
					*pDest |= Color;
				pDest++;
				x++;
			}
			y++;
			pLine -= DestPitch;
		}
		break;
	case BLEND_MODE_XOR:
		pLine = pDest - DestTop * DestPitch + DestLeft;
		y = DestTop;
		while(y < DestBottom)
		{
			pDest = pLine;
			x = DestLeft;
			while(x < DestRight)
			{
				Inverse.Transform(fx, fy, (FLOAT)x, (FLOAT)y);
				if(fx >= fSrcLeft && fx < fSrcRight && fy >= fSrcTop && fy < fSrcBottom)
					*pDest ^= Color;
				pDest++;
				x++;
			}
			y++;
			pLine -= DestPitch;
		}
		break;
	case BLEND_MODE_MULTIPLY:
		pLine = pDest - DestTop * DestPitch + DestLeft;
		y = DestTop;
		while(y < DestBottom)
		{
			pDest = pLine;
			x = DestLeft;
			while(x < DestRight)
			{
				Inverse.Transform(fx, fy, (FLOAT)x, (FLOAT)y);
				if(fx >= fSrcLeft && fx < fSrcRight && fy >= fSrcTop && fy < fSrcBottom)
					*pDest = MultiplyColor(*pDest, Color);
				pDest++;
				x++;
			}
			y++;
			pLine -= DestPitch;
		}
		break;
	case BLEND_MODE_ADD:
		pLine = pDest - DestTop * DestPitch + DestLeft;
		y = DestTop;
		while(y < DestBottom)
		{
			pDest = pLine;
			x = DestLeft;
			while(x < DestRight)
			{
				Inverse.Transform(fx, fy, (FLOAT)x, (FLOAT)y);
				if(fx >= fSrcLeft && fx < fSrcRight && fy >= fSrcTop && fy < fSrcBottom)
					*pDest = AddColor(*pDest, Color);
				pDest++;
				x++;
			}
			y++;
			pLine -= DestPitch;
		}
		break;
	case BLEND_MODE_SUBTRACT:
		pLine = pDest - DestTop * DestPitch + DestLeft;
		y = DestTop;
		while(y < DestBottom)
		{
			pDest = pLine;
			x = DestLeft;
			while(x < DestRight)
			{
				Inverse.Transform(fx, fy, (FLOAT)x, (FLOAT)y);
				if(fx >= fSrcLeft && fx < fSrcRight && fy >= fSrcTop && fy < fSrcBottom)
					*pDest = SubtractColor(*pDest, Color);
				pDest++;
				x++;
			}
			y++;
			pLine -= DestPitch;
		}
		break;
	}
	return TRUE;
}

BOOL EffectPaintRect(void* pDestBits, DWORD DestPitch, DWORD DestHeight, RECT* pDestRect, RECT* pSrcRect, COLORREF Color, DWORD BlendMode, TRANSFORMMATRIX* pMatrix, TRANSFORMMATRIX* pInverse)
{
	DWORD* pDest;
	DWORD* pLine;
	LONG x;
	LONG y;
	LONG DestLeft;
	LONG DestRight;
	LONG DestTop;
	LONG DestBottom;
	DWORD Alpha;
	DWORD InvAlpha;
	pDest = (DWORD*)pDestBits + DestPitch * (DestHeight - 1);
	DestLeft = pDestRect->left;
	DestRight = pDestRect->right;
	DestTop = pDestRect->top;
	DestBottom = pDestRect->bottom;
	if(DestLeft < pSrcRect->left)
		DestLeft = pSrcRect->left;
	if(DestRight > pSrcRect->right)
		DestRight = pSrcRect->right;
	if(DestTop < pSrcRect->top)
		DestTop = pSrcRect->top;
	if(DestBottom > pSrcRect->bottom)
		DestBottom = pSrcRect->bottom;
	if(DestLeft < 0)
		DestLeft = 0;
	if(DestRight > (LONG)DestPitch)
		DestRight = (LONG)DestPitch;
	if(DestTop < 0)
		DestTop = 0;
	if(DestBottom > (LONG)DestHeight)
		DestBottom = (LONG)DestHeight;
	if(DestLeft >= DestRight || DestTop >= DestBottom)
		return TRUE;
	Alpha = (Color & 0xff000000) >> 24;
	InvAlpha = 0x00000100 - Alpha;
	Color = ((Color & 0x000000ff) << 16) | (Color & 0x0000ff00) | ((Color & 0x00ff0000) >> 16);
	switch(BlendMode)
	{
	case BLEND_MODE_DEFAULT:
		if(Alpha == 0)
		{
			pLine = pDest - DestTop * DestPitch + DestLeft;
			y = DestTop;
			while(y < DestBottom)
			{
				pDest = pLine;
				x = DestLeft;
				while(x < DestRight)
				{
					*pDest = Color;
					pDest++;
					x++;
				}
				y++;
				pLine -= DestPitch;
			}
		}
		else
		{
			pLine = pDest - DestTop * DestPitch + DestLeft;
			y = DestTop;
			while(y < DestBottom)
			{
				pDest = pLine;
				x = DestLeft;
				while(x < DestRight)
				{
					*pDest = BlendColorAlpha(Color, *pDest, Alpha, InvAlpha);
					pDest++;
					x++;
				}
				y++;
				pLine -= DestPitch;
			}
		}
		break;
	case BLEND_MODE_AND:
		pLine = pDest - DestTop * DestPitch + DestLeft;
		y = DestTop;
		while(y < DestBottom)
		{
			pDest = pLine;
			x = DestLeft;
			while(x < DestRight)
			{
				*pDest &= Color;
				pDest++;
				x++;
			}
			y++;
			pLine -= DestPitch;
		}
		break;
	case BLEND_MODE_OR:
		pLine = pDest - DestTop * DestPitch + DestLeft;
		y = DestTop;
		while(y < DestBottom)
		{
			pDest = pLine;
			x = DestLeft;
			while(x < DestRight)
			{
				*pDest |= Color;
				pDest++;
				x++;
			}
			y++;
			pLine -= DestPitch;
		}
		break;
	case BLEND_MODE_XOR:
		pLine = pDest - DestTop * DestPitch + DestLeft;
		y = DestTop;
		while(y < DestBottom)
		{
			pDest = pLine;
			x = DestLeft;
			while(x < DestRight)
			{
				*pDest ^= Color;
				pDest++;
				x++;
			}
			y++;
			pLine -= DestPitch;
		}
		break;
	case BLEND_MODE_MULTIPLY:
		pLine = pDest - DestTop * DestPitch + DestLeft;
		y = DestTop;
		while(y < DestBottom)
		{
			pDest = pLine;
			x = DestLeft;
			while(x < DestRight)
			{
				*pDest = MultiplyColor(*pDest, Color);
				pDest++;
				x++;
			}
			y++;
			pLine -= DestPitch;
		}
		break;
	case BLEND_MODE_ADD:
		pLine = pDest - DestTop * DestPitch + DestLeft;
		y = DestTop;
		while(y < DestBottom)
		{
			pDest = pLine;
			x = DestLeft;
			while(x < DestRight)
			{
				*pDest = AddColor(*pDest, Color);
				pDest++;
				x++;
			}
			y++;
			pLine -= DestPitch;
		}
		break;
	case BLEND_MODE_SUBTRACT:
		pLine = pDest - DestTop * DestPitch + DestLeft;
		y = DestTop;
		while(y < DestBottom)
		{
			pDest = pLine;
			x = DestLeft;
			while(x < DestRight)
			{
				*pDest = SubtractColor(*pDest, Color);
				pDest++;
				x++;
			}
			y++;
			pLine -= DestPitch;
		}
		break;
	}
	return TRUE;
}

BOOL EffectMonochromeRect(void* pDestBits, DWORD DestPitch, DWORD DestHeight, RECT* pDestRect, RECT* pSrcRect, COLORREF Color, DWORD BlendMode, TRANSFORMMATRIX* pMatrix, TRANSFORMMATRIX* pInverse)
{
	DWORDBYTE* pDest;
	DWORDBYTE* pLine;
	LONG x;
	LONG y;
	LONG DestLeft;
	LONG DestRight;
	LONG DestTop;
	LONG DestBottom;
	pDest = (DWORDBYTE*)pDestBits + DestPitch * (DestHeight - 1);
	DestLeft = pDestRect->left;
	DestRight = pDestRect->right;
	DestTop = pDestRect->top;
	DestBottom = pDestRect->bottom;
	if(DestLeft < pSrcRect->left)
		DestLeft = pSrcRect->left;
	if(DestRight > pSrcRect->right)
		DestRight = pSrcRect->right;
	if(DestTop < pSrcRect->top)
		DestTop = pSrcRect->top;
	if(DestBottom > pSrcRect->bottom)
		DestBottom = pSrcRect->bottom;
	if(DestLeft < 0)
		DestLeft = 0;
	if(DestRight > (LONG)DestPitch)
		DestRight = (LONG)DestPitch;
	if(DestTop < 0)
		DestTop = 0;
	if(DestBottom > (LONG)DestHeight)
		DestBottom = (LONG)DestHeight;
	if(DestLeft >= DestRight || DestTop >= DestBottom)
		return TRUE;
	pLine = pDest - DestTop * DestPitch + DestLeft;
	y = DestTop;
	while(y < DestBottom)
	{
		pDest = pLine;
		x = DestLeft;
		while(x < DestRight)
		{
			*pDest = g_MonochromeTable[(WORD)pDest->b[0] + pDest->b[1] + pDest->b[2]];
			pDest++;
			x++;
		}
		y++;
		pLine -= DestPitch;
	}
	return TRUE;
}

//	w肳ꂽԍ̌ʂ̏ĂB
//	̊֐__stdcallƂăGNX|[gĂB
//	ɏꍇ1AłȂꍇ0ԂĂB
//	pDestBits͏o͐̉摜f[^̃|C^܂B
//	摜f[^̓sNZ̔zƂĊi[܂B
//	摜f[^̃sNŹAes͍EɁAe͉ցAs̖[ɒBƂ̍s̐擪ɑ悤ɕł܂B
//	܂pDestBits͍̃sNZwĂ܂B
//	܂AesNẐ͎悤4oCg̃f[^ō\܂B
//	struct
//	{
//		BYTE red;
//		BYTE green;
//		BYTE blue;
//		BYTE alpha;
//	};
//	Aalpha͏0łȂ΂Ȃ܂B
//	DestPitch͈s̃sNŽ܂B
//	Aes̑SẴsNZLłƂ͌܂B
//	DestHeight̓sNŽ̗܂B
//	Wɂ͍(0, 0)ƂAExAyƂ܂B
//	āAW(x, y)̃sNZpDestBits[x + DestPitch * (DestHeight - y - 1)]ŕ\܂B
//	pDestRect͎QƉ\ȃsNZ͈̔͂܂B
//	͈̔͂𒴂ăsNZ̃f[^QƂĂ͂܂B
//	͈̔͂̓sNZPʂ̍Wŕ\܂B
//	pDestRect->leftpDestRect->top0ȏłȂ΂Ȃ܂B
//	pDestRect->rightpDestRect->bottom͂ꂼDestPitchDestHeightłȂ΂Ȃ܂B
//	͈̔͂𒴂Ăꍇ͈͂̔͂Ɏ܂悤ɏĂB
//	pSrcRect͌ʂ̓Kp͈͂܂B
//	͈͕̔͂ό`ÕsNZPʂ̍Wŕ\܂B
//	pSrcRect->leftpSrcRect->top0ȏłȂ΂Ȃ܂B
//	͈̔͂𒴂Ăꍇ͈͂̔͂Ɏ܂悤ɏĂB
//	Color̓CxgɎw肳ꂽF܂B
//	Color͎̂悤ȍ\̂ƓłB
//	struct
//	{
//		BYTE blue;
//		BYTE green;
//		BYTE red;
//		BYTE alpha;
//	};
//	Aalpha͕sx\A1ɋ߂ÂقǓɁA255ɋ߂ÂقǕsɁA0̂Ƃ͊SɕsƂȂ܂B
//	BlendMode͊esNZ̏@܂B
//	BlendModeBLEND_MODE_DEFAULTȊÔƂAColor̕sxKv͂܂B
//	pMatrix͌ʂ̓Kp͈͂o͈͐̔͂ɕϊs̃|C^܂B
//	pInverse͏o͈͐̔͂ʂ̓Kp͈͂ɕϊs̃|C^܂B
//	{IpInversepMatrix̋tsłA̓eɂĂ͋tsł͂Ȃꍇ܂B
//	ʂ̓eɂĂpSrcRectAColorABlendModeApMatrixApInversegpȂA
//	܂͏LƂ͈قȂ߂iႦ΁ȀlȂǂɂjƂ\łB
//	̓Iȏ@ɂĂ͏̃R[hQlɂĂB
BOOL CALLBACK TransformEffect(DWORD Effect, void* pDestBits, DWORD DestPitch, DWORD DestHeight, RECT* pDestRect, RECT* pSrcRect, COLORREF Color, DWORD BlendMode, TRANSFORMMATRIX* pMatrix, TRANSFORMMATRIX* pInverse)
{
	switch(Effect)
	{
	case 0:
		return EffectNull(pDestBits, DestPitch, DestHeight, pDestRect, pSrcRect, Color, BlendMode, pMatrix, pInverse);
		break;
	case 1:
		return EffectPaint(pDestBits, DestPitch, DestHeight, pDestRect, pSrcRect, Color, BlendMode, pMatrix, pInverse);
		break;
	case 2:
		return EffectPaintRect(pDestBits, DestPitch, DestHeight, pDestRect, pSrcRect, Color, BlendMode, pMatrix, pInverse);
		break;
	case 3:
		return EffectMonochromeRect(pDestBits, DestPitch, DestHeight, pDestRect, pSrcRect, Color, BlendMode, pMatrix, pInverse);
		break;
	}
	return FALSE;
}

